﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using foxit;
using foxit.pdf;
using foxit.addon.xfa;
using foxit.common.fxcrt;

namespace PDFReader_Demo_CSharp.UI
{
    public class XFAAppProviderHandler : foxit.addon.xfa.AppProviderCallback
    {
        public XFAAppProviderHandler()
        {

        }

        public override void Beep(AppProviderCallback.BeepType type)
        {
            string funname = "XFA Beep\n\n";
            string type_string = "";
            switch (type)
            {
                case AppProviderCallback.BeepType.e_BeepTypeError:
                    type_string = "Error";
                    break;
                case AppProviderCallback.BeepType.e_BeepTypeWarning:
                    type_string = "Warning";
                    break;
                case AppProviderCallback.BeepType.e_BeepTypeQuestion:
                    type_string = "Question";
                    break;
                case AppProviderCallback.BeepType.e_BeepTypeStatus:
                    type_string = "Status";
                    break;
                case AppProviderCallback.BeepType.e_BeepTypeDefault:
                    type_string = "Default";
                    break;
                default:
                    type_string = "not defined";
                    break;
            }
            string message_string = funname + type_string;

            System.Windows.Forms.MessageBox.Show(message_string);
        }

        public override void Dispose()
        {
            base.Dispose();
        }

        public override FileReaderCallback DownLoadUrl(string url)
        {
            System.Windows.Forms.MessageBox.Show(string.Format("DownLoadUrl {0}", url));

            return null;
        }

        public override string GetAppInfo(AppProviderCallback.AppInfo app_info)
        {
            switch (app_info) {
                case AppProviderCallback.AppInfo.e_AppInfoVersion:
                    return "11.0";
                case AppProviderCallback.AppInfo.e_AppInfoLanguage:
                    return "en-US";
                case AppProviderCallback.AppInfo.e_AppInfoName:
                    return "Acrobat";
                case AppProviderCallback.AppInfo.e_AppInfoType:
                    return "Exchange-Pro";
                case AppProviderCallback.AppInfo.e_AppInfoVariation:
                    return "Full";
                case AppProviderCallback.AppInfo.e_AppInfoPlatform:
                    return "WIN";
                default:
                    return "";
            }
        }

        public override string LoadString(AppProviderCallback.StringID string_id)
        {
            string ret_string = "";
            switch (string_id)
            {
                case AppProviderCallback.StringID.e_StringIDValidateFailed:
                    ret_string = "%s validate failed";
                    break;
                case AppProviderCallback.StringID.e_StringIDCalcOverride:
                    ret_string = "Calculate Override";
                    break;
                case AppProviderCallback.StringID.e_StringIDModifyField:
                    ret_string = "Are you sure you want to modify this field?";
                    break;
                case AppProviderCallback.StringID.e_StringIDNotModifyField:
                    ret_string = "You are not allowed to modify this field.";
                    break;
                case AppProviderCallback.StringID.e_StringIDAppName:
                    ret_string = "Foxit SDK";
                    break;
                case AppProviderCallback.StringID.e_StringIDImageFilter:
                    ret_string = "Image Files(*.bmp;*.jpg;*.png;*.gif;*.tif)|*.bmp;*.jpg;*.png;*.gif;*.tif|All Files(*.*)|*.*||";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnknownCaught:
                    ret_string = "unknown error is catched!";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnableToSet:
                    ret_string = "Unable to set ";
                    break;
                case AppProviderCallback.StringID.e_StringIDValueExcalmatory:
                    ret_string = " value!";
                    break;
                case AppProviderCallback.StringID.e_StringIDInvalidEnumValue:
                    ret_string = "Invalid enumerated value: ";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnsupportMethod:
                    ret_string = "Unsupport %s method.";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnsupportProperty:
                    ret_string = "Usupport %s property.";
                    break;
                case AppProviderCallback.StringID.e_StringIDInvalidPropertySetOperation:
                    ret_string = "Invalid property set operation;";
                    break;
                case AppProviderCallback.StringID.e_StringIDNotDefaultValue:
                    ret_string = " doesn't have a default property";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnableSetLanguage:
                    ret_string = "Unable to set language value!";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnableSetNumPages:
                    ret_string = "Unable to set numPages value!";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnableSetPlatformValue:
                    ret_string = "Unable to set platform value!";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnableSetValidationsEnabledValue:
                    ret_string = "Unable to set validationsEnabled value!";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnableSetValidationsValue:
                    ret_string = "Unable to set variation value!";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnableSetVersion:
                    ret_string = "Unable to set version value!";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnableSetReady:
                    ret_string = "Unable to set ready value!";
                    break;
                case AppProviderCallback.StringID.e_StringIDNumberOfOccur:
                    ret_string = "The element [%s] has violated its allowable number of occurrences";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnableSetClassName:
                    ret_string = "Unable to set className value!";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnableSetLengthValue:
                    ret_string = "Unable to set length value!";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnsupportChar:
                    ret_string = "unsupported char '%c'";
                    break;
                case AppProviderCallback.StringID.e_StringIDBadSuffix:
                    ret_string = "bad suffix on number";
                    break;
                case AppProviderCallback.StringID.e_StringIDExpectedIdent:
                    ret_string = "expected identifier instead of '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDExpectedString:
                    ret_string = "expected '%s' instead of '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDInvalidateChar:
                    ret_string = "invalidate char '%c'";
                    break;
                case AppProviderCallback.StringID.e_StringIDRedefinition:
                    ret_string = "'%s' redefinition ";
                    break;
                case AppProviderCallback.StringID.e_StringIDInvalidToken:
                    ret_string = "invalidate token '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDInvalidExpression:
                    ret_string = "invalidate expression '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDUndefineIdentifier:
                    ret_string = "undefined identifier '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDInvalidateLeftValue:
                    ret_string = "invalidate left-value '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDCompilerError:
                    ret_string = "compiler error";
                    break;
                case AppProviderCallback.StringID.e_StringIDCannotModifyValue:
                    ret_string = "can't modify the '%s' value";
                    break;
                case AppProviderCallback.StringID.e_StringIDParametersError:
                    ret_string = "function '%s' has not %d parameters";
                    break;
                case AppProviderCallback.StringID.e_StringIDExpectedEndIf:
                    ret_string = "expected 'endif' instead of '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDUnexpectedExpression:
                    ret_string = "unexpected expression '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDConditionIsNull:
                    ret_string = "condition is null";
                    break;
                case AppProviderCallback.StringID.e_StringIDIllegalBreak:
                    ret_string = "illegal break";
                    break;
                case AppProviderCallback.StringID.e_StringIDIllegalContinue:
                    ret_string = "illegal continue";
                    break;
                case AppProviderCallback.StringID.e_StringIDExpectedOperator:
                    ret_string = "expected operator '%s' instead of '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDDivideZero:
                    ret_string = "divide by zero";
                    break;
                case AppProviderCallback.StringID.e_StringIDCannotCovertToObject:
                    ret_string = "%s.%s can not covert to object";
                    break;
                case AppProviderCallback.StringID.e_StringIDNotFoundContainer:
                    ret_string = "can not found container '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDNotFoundProperty:
                    ret_string = "can not found property '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDNotFoundMethod:
                    ret_string = "can not found method '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDNotFoundConst:
                    ret_string = "can not found const '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDNotAssignObject:
                    ret_string = "can not direct assign value to object";
                    break;
                case AppProviderCallback.StringID.e_StringIDInvalidateInstruction:
                    ret_string = "invalidate instruction";
                    break;
                case AppProviderCallback.StringID.e_StringIDExpectedNumber:
                    ret_string = "expected number instead of '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDValidateOutOfArray:
                    ret_string = "validate access index '%s' out of array";
                    break;
                case AppProviderCallback.StringID.e_StringIDCannotAssign:
                    ret_string = "can not assign to %s";
                    break;
                case AppProviderCallback.StringID.e_StringIDNotFoundFunction:
                    ret_string = "can not found '%s' function";
                    break;
                case AppProviderCallback.StringID.e_StringIDIsNotArray:
                    ret_string = "'%s' doesn't an array";
                    break;
                case AppProviderCallback.StringID.e_StringIDOutOfArrayRange:
                    ret_string = "out of range of '%s' array";
                    break;
                case AppProviderCallback.StringID.e_StringIDNotSupportArrayCalculate:
                    ret_string = "'%s' operator can not support array calculate";
                    break;
                case AppProviderCallback.StringID.e_StringIDArgumentNotArray:
                    ret_string = "'%s' function's %d argument can not be array";
                    break;
                case AppProviderCallback.StringID.e_StringIDArgumentExpectContainer:
                    ret_string = "'%s' argument expected a container";
                    break;
                case AppProviderCallback.StringID.e_StringIDAccessProertyInNotObject:
                    ret_string = "an attempt was made to reference property '%s' of a non-object in SOM expression %s";
                    break;
                case AppProviderCallback.StringID.e_StringIDFunctionBuildIn:
                    ret_string = "function '%s' is buildin";
                    break;
                case AppProviderCallback.StringID.e_StringIDErrorMessage:
                    ret_string = "%s : %s";
                    break;
                case AppProviderCallback.StringID.e_StringIDIndexValueOutOfBounds:
                    ret_string = "Index value is out of bounds";
                    break;
                case AppProviderCallback.StringID.e_StringIDIncorrectNumberOfMethod:
                    ret_string = "Incorrect number of parameters calling method '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDArgumentMismatch:
                    ret_string = "Argument mismatch in property or function argument";
                    break;
                case AppProviderCallback.StringID.e_StringIDInvalidEnumerate:
                    ret_string = "Invalid enumerated value: %s";
                    break;
                case AppProviderCallback.StringID.e_StringIDInvalidAppend:
                    ret_string = "Invalid append operation: %s cannot have a child element of %s";
                    break;
                case AppProviderCallback.StringID.e_StringIDSOMExpectedList:
                    ret_string = "SOM expression breaked list when single result was expected";
                    break;
                case AppProviderCallback.StringID.e_StringIDNotHaveProperty:
                    ret_string = "'%s' doesn't have property '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDInvalidNodeType:
                    ret_string = "Invalid node type : '%s'";
                    break;
                case AppProviderCallback.StringID.e_StringIDViolateBoundary:
                    ret_string = "The element [%s] has violated its allowable number of occurrences";
                    break;
                case AppProviderCallback.StringID.e_StringIDServerDeny:
                    ret_string = "Server does not permit";
                    break;
                case AppProviderCallback.StringID.e_StringIDWeekDaySun:
                    ret_string = "Sunday";
                    break;
                case AppProviderCallback.StringID.e_StringIDWeekDayMon:
                    ret_string = "Monday";
                    break;
                case AppProviderCallback.StringID.e_StringIDWeekDayTue:
                    ret_string = "Tuesday";
                    break;
                case AppProviderCallback.StringID.e_StringIDWeekDayWed:
                    ret_string = "Wednesday";
                    break;
                case AppProviderCallback.StringID.e_StringIDWeekDayThu:
                    ret_string = "Thursday";
                    break;
                case AppProviderCallback.StringID.e_StringIDWeekDayFri:
                    ret_string = "Friday";
                    break;
                case AppProviderCallback.StringID.e_StringIDWeekDaySat:
                    ret_string = "Saturday";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthJan:
                    ret_string = "January";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthFeb:
                    ret_string = "February";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthMarch:
                    ret_string = "March";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthApril:
                    ret_string = "April";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthMay:
                    ret_string = "May";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthJune:
                    ret_string = "June";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthJuly:
                    ret_string = "July";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthAug:
                    ret_string = "August";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthSep:
                    ret_string = "September";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthOct:
                    ret_string = "October";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthNov:
                    ret_string = "November";
                    break;
                case AppProviderCallback.StringID.e_StringIDMonthDec:
                    ret_string = "December";
                    break;
                case AppProviderCallback.StringID.e_StringIDToday:
                    ret_string = "Today";
                    break;
                case AppProviderCallback.StringID.e_StringIDValidateLimit:
                    ret_string = "Message limit exceeded. Remaining %d validation errors not reported.";
                    break;
                case AppProviderCallback.StringID.e_StringIDValidateNullWarning:
                    ret_string = "%s cannot be left blank. To ignore validations for %s, click Ignore.";
                    break;
                case AppProviderCallback.StringID.e_StringIDValidateNullError:
                    ret_string = "%s cannot be left blank.";
                    break;
                case AppProviderCallback.StringID.e_StringIDValidateWarning:
                    ret_string = "The value you entered for %s is invalid. To ignore validations for %s, click Ignore.";
                    break;
                case AppProviderCallback.StringID.e_StringIDValidateError:
                    ret_string = "The value you entered for %s is invalid.";
                    break;
                case AppProviderCallback.StringID.e_StringIDValidateNumberError:
                    ret_string = "Illegal value:cannot assign '%s' to %s.";
                    break;
                case AppProviderCallback.StringID.e_StringIDScriptFailedError:
                    ret_string = "Script failed(language is %s;context is %s) script=%s ";
                    break;
                case AppProviderCallback.StringID.e_StringIDScriptInvalidValue:
                    ret_string = "Error:Invalid enumerated value:%s";
                    break;
                case AppProviderCallback.StringID.e_StringIDSubmitValidateNullError:
                    ret_string = "At least one required field was empty.Please fill in the required fields(highlighted) before continuing.";
                    break;
            }

            return ret_string;
        }

        public override AppProviderCallback.MsgBoxButtonID MsgBox(string message, string title, AppProviderCallback.MsgBoxIconType icon_type, AppProviderCallback.MsgBoxButtonType button_type)
        {
            return GetSdkMsgBoxButtonID(System.Windows.Forms.MessageBox.Show(message, title, GetMsgBoxButtonType(button_type), GetMsgBoxIconType(icon_type)));
        }

        public override string PostRequestURL(string url, string data, string content_type, string encode, string header)
        {
            return "PostRequestUrl";
        }

        public override bool PutRequestURL(string url, string data, string encode)
        {
            return false;
        }

        public override void Release()
        {

        }

        public override string Response(string question, string title, string default_answer, bool is_mask)
        {
            string message_string = string.Format("question: {0}\r\ntitle:{1}\r\ndefault_answer:{2}\r\nis mask:{3}", question, title, default_answer, is_mask);
            System.Windows.Forms.MessageBox.Show(message_string);

            return "answer";
        }

        public override foxit.common.WStringArray ShowFileDialog(string string_title, string string_filter, bool is_openfile_dialog)
        {
            return new foxit.common.WStringArray();
        }

        private MessageBoxButtons GetMsgBoxButtonType(AppProviderCallback.MsgBoxButtonType button_type)
        {
            MessageBoxButtons msg_box_button = MessageBoxButtons.OK;
            switch (button_type)
            {
                case AppProviderCallback.MsgBoxButtonType.e_MsgBtnTypeOK:
                    msg_box_button = MessageBoxButtons.OK;
                    break;
                case AppProviderCallback.MsgBoxButtonType.e_MsgBtnTypeOKCancel:
                    msg_box_button = MessageBoxButtons.OKCancel;
                    break;
                case AppProviderCallback.MsgBoxButtonType.e_MsgBtnTypeYesNo:
                    msg_box_button = MessageBoxButtons.YesNo;
                    break;
                case AppProviderCallback.MsgBoxButtonType.e_MsgBtnTypeYesNoCancel:
                    msg_box_button = MessageBoxButtons.YesNoCancel;
                    break;
            }

            return msg_box_button;
        }

        private MessageBoxIcon GetMsgBoxIconType(AppProviderCallback.MsgBoxIconType icon_type)
        {
            MessageBoxIcon msg_box_icon = MessageBoxIcon.None;
            switch (icon_type)
            {
                case AppProviderCallback.MsgBoxIconType.e_MsgBoxIconError:
                    msg_box_icon = MessageBoxIcon.Error;
                    break;
                case AppProviderCallback.MsgBoxIconType.e_MsgBoxIconWarning:
                    msg_box_icon = MessageBoxIcon.Warning;
                    break;
                case AppProviderCallback.MsgBoxIconType.e_MsgBoxIconQuestion:
                    msg_box_icon = MessageBoxIcon.Question;
                    break;
                case AppProviderCallback.MsgBoxIconType.e_MsgBoxIconStatus:
                    msg_box_icon = MessageBoxIcon.Information;
                    break;
            }

            return msg_box_icon;
        }

        private AppProviderCallback.MsgBoxButtonID GetSdkMsgBoxButtonID(DialogResult id)
        {
            AppProviderCallback.MsgBoxButtonID msg_box_button_id = AppProviderCallback.MsgBoxButtonID.e_MsgBtnIDOK;
            switch (id)
            {
                case DialogResult.OK:
                    msg_box_button_id = AppProviderCallback.MsgBoxButtonID.e_MsgBtnIDOK;
                    break;
                case DialogResult.Cancel:
                    msg_box_button_id = AppProviderCallback.MsgBoxButtonID.e_MsgBtnIDCancel;
                    break;
                case DialogResult.Yes:
                    msg_box_button_id = AppProviderCallback.MsgBoxButtonID.e_MsgBtnIDYes;
                    break;
                case DialogResult.No:
                    msg_box_button_id = AppProviderCallback.MsgBoxButtonID.e_MsgBtnIDNo;
                    break;
                default:
                    break;
            }

            return msg_box_button_id;
        }
    }
}
